19-二分-值域二分-有序矩阵中第 K 小的元素

这是二分法的第19篇算法,力扣链接。

给你一个 n x n矩阵 matrix ,其中每行和每列元素均按升序排序,找到矩阵中第 k 小的元素。

请注意,它是 排序后 的第 k 小元素,而不是第 k 个 不同 的元素。

你必须找到一个内存复杂度优于 O(n2) 的解决方案。

示例 1:

复制代码
输入:matrix = [[1,5,9],[10,11,13],[12,13,15]], k = 8
输出:13
解释:矩阵中的元素为 [1,5,9,10,11,12,13,13,15],第 8 小元素是 13

这道题很抽象,他告诉我们行和列都是有序的。但是不代表下一列一定大于上一行。

老规矩,直接上暴力法,先把所有数字存起来然后排序。

Go 复制代码
func kthSmallest(matrix [][]int, k int) int {
	nums := make([]int, len(matrix)*len(matrix[0]))
	index := 0
	for _, row := range matrix {
		for _, num := range row {
			nums[index] = num
			index++
		}
	}
	sort.Ints(nums)
	return nums[k-1]
}

那这道题二分法怎么搞呢?

首先明确,无论这个分布怎么诡异,在matrix00的数一定matrixlen(matrix)-1len(matrix\[0)-1]的数小。我门可以利用这两个值当作边界,往中间找mid,移动左右边界的逻辑可以根据小于等于mid的数的多少。当左右指针相等的时候返回指针就可以了。

这时候还会有一个疑问,当左右指针相等的时候,那个边界的值真的存在吗,这个值不是根据mid左右移动算出来的吗。

其实很简单,求出矩阵元素排序后,把矩阵分成两份,且使得前一份包含k个元素的数值范围左边界值(满足条件的数值可能是个范围,有些值不存在矩阵中,但这个左边界值一定在矩阵中)。可以尝试去推导一下,会发现这个结论是存在的。

上代码:

Go 复制代码
func kthSmallest(matrix [][]int, k int) int {
	l, r := matrix[0][0], matrix[len(matrix)-1][len(matrix[0])-1]
	for l <= r {
		mid := l + (r-l)/2
		if count(mid, matrix) < k {
			l = mid + 1
		} else {
			r = mid - 1
		}
	}
	return l
}

func count(mid int, matrix [][]int) int {
	result, x, y := 0, len(matrix)-1, 0
	for x >= 0 && y < len(matrix[0]) {
		if matrix[x][y] <= mid {
			result += x + 1
			y++
		} else {
			x--
		}
	}
	return result
}

这个count是有点学问的,这个是一列一列的加数字,梯形的方式加。

相关推荐
罗西的思考2 小时前
【Agentic RL】Dressage Staleness 控制深度分析
人工智能·算法·机器学习
quaer2 小时前
弗洛伊德算法--判圈法寻找环的入口O(n) O(1)
数据结构·算法
高晶4 小时前
无乘法器实现LC二阶滤波器:基于移位运算的快速算法与四种精度推导
算法·设计模式·程序员
ysbfsy4 小时前
大数计算思路
算法
高晶4 小时前
主从自动分配算法:平均值乘以设备数一半的选举基准值解析
算法·设计模式·程序员
学电子她就能回来吗5 小时前
LeetCode Hot 100|普通数组专题学习笔记(零基础版)
笔记·算法·leetcode
用户老李5 小时前
反向传播计算梯度举例
算法
niyongsheng5 小时前
多智能体连续时间内路径规划:AA-SIPP(m) 的 Rust 实现与算法
算法·rust·机器人
302wanger6 小时前
DeepSeek-V4.1-Flash-1017 免费用到1024,速来
算法
lisw056 小时前
微分与积分的本质区别解析
算法·数学建模·极限编程